package com.aliyun.iot.aep.demo;

import android.app.Activity;
import android.app.Application;
import android.os.Bundle;

import com.aliyun.iot.aep.configmanager.SimpleConfigManager;
import com.aliyun.iot.aep.demo.utils.FloatWindowHelper;

/**
 * Created by feijie.xfj on 17/11/19.
 */

public class DemoAppActivityLifeCycle implements Application.ActivityLifecycleCallbacks {

    private int startActivityCount = 0, stopActivityCount = 0;

    private FloatWindowHelper windowHelper;

    private boolean isBackground;

    private void refreshFloatWindow() {
        if (startActivityCount > stopActivityCount) {
            windowHelper.showFloatWindow();
        } else {
            windowHelper.removeFloatWindow();
        }
    }

    public DemoAppActivityLifeCycle(Application application) {
        windowHelper = new FloatWindowHelper(application);
    }

    @Override
    public void onActivityCreated(Activity activity, Bundle savedInstanceState) {

    }

    @Override
    public void onActivityStarted(Activity activity) {
        startActivityCount++;
        refreshFloatWindow();
        if (true == isBackground) {
            isBackground = false;
            SimpleConfigManager.getInstance(activity.getApplication()).onBackToFront();
        }
    }

    @Override
    public void onActivityResumed(Activity activity) {

    }

    @Override
    public void onActivityPaused(Activity activity) {

    }

    @Override
    public void onActivityStopped(Activity activity) {
        stopActivityCount++;
        refreshFloatWindow();
        if (stopActivityCount == startActivityCount) {
            isBackground = true;
        }
    }

    @Override
    public void onActivitySaveInstanceState(Activity activity, Bundle outState) {

    }

    @Override
    public void onActivityDestroyed(Activity activity) {

    }
}
