package com.aliyun.iot.aep.demo.page.account;

import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.aliyun.iot.demo.R;
import com.aliyun.iot.aep.sdk.framework.AActivity;
import com.aliyun.iot.aep.sdk.login.ILoginCallback;
import com.aliyun.iot.aep.sdk.login.ILogoutCallback;
import com.aliyun.iot.aep.sdk.login.LoginBusiness;

/**
 * Created by feijie.xfj on 17/11/7.
 */

public class AccountActivity extends AActivity {

    private View loginTV;
    private View logoutTV;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        setContentView(R.layout.account_activity);
        super.onCreate(savedInstanceState);

        ((TextView) this.findViewById(R.id.topbar_title_textview)).setText(R.string.account_title);
        this.findViewById(R.id.topbar_back_imageview).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });

        this.loginTV = this.findViewById(R.id.account_login_textview);
        this.logoutTV = this.findViewById(R.id.account_logout_textview);

        loginTV.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoginBusiness.login(new ILoginCallback() {
                    @Override
                    public void onLoginSuccess() {
                        toast(getApplication().getString(R.string.account_login_success));
                    }

                    @Override
                    public void onLoginFailed(int code, String error) {
                        toast(getApplication().getString(R.string.account_login_failed) + error);
                    }
                });
            }
        });


        logoutTV.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                LoginBusiness.logout(new ILogoutCallback() {
                    @Override
                    public void onLogoutSuccess() {
                        toast(getApplication().getString(R.string.account_logout_success));
                    }

                    @Override
                    public void onLogoutFailed(int code, String error) {
                        toast(getApplication().getString(R.string.account_logout_failed) + error);
                    }
                });
            }
        });
    }


    private void toast(final String str) {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(AccountActivity.this, str, Toast.LENGTH_SHORT).show();
            }
        });
    }
}
