package com.aliyun.iot.aep.demo.page.main;

import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.os.CountDownTimer;
import android.widget.TextView;

import com.aliyun.iot.aep.component.router.Router;
import com.aliyun.iot.demo.R;
import com.aliyun.iot.aep.sdk.framework.AActivity;
import com.aliyun.iot.aep.utils.ALog;

/**
 * Created by feijie.xfj on 17/11/27.
 */
//launcher页面不可以singleTask
public class StartActivity extends AActivity {
    private static final String TAG = "StartActivity";

    private CountDownTimer countDownTimer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.start_activity);
        ((TextView) findViewById(R.id.start_version_textview)).setText("当前版本：" + getVersionName());
        countDownTimer = new CountDownTimer(2000, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {

            }

            @Override
            public void onFinish() {
                Router.getInstance().toUrl(StartActivity.this, "page/main");
                finish();
            }
        };
        countDownTimer.start();
    }

    @Override
    protected void onDestroy() {
        if (countDownTimer != null) {
            countDownTimer.cancel();
        }
        countDownTimer = null;
        super.onDestroy();
    }

    /* methods: help */
    private String getVersionName() {
        String ret = "";

        PackageManager packageManager = this.getPackageManager();
        PackageInfo packageInfo;
        try {
            if (null != packageManager) {
                packageInfo = packageManager.getPackageInfo(this.getPackageName(), 0);
                ret = null != packageInfo ? packageInfo.versionName : "";
            }
        } catch (Exception ex) {
            ALog.e(TAG, "request version name failed", ex);
        }

        return ret;
    }
}
