package com.aliyun.iot.aep.demo.sdk.delegate;

import android.app.Application;

import com.aliyun.alink.linksdk.channel.mobile.api.IMobileConnectListener;
import com.aliyun.alink.linksdk.channel.mobile.api.MobileChannel;
import com.aliyun.alink.linksdk.channel.mobile.api.MobileConnectConfig;
import com.aliyun.alink.linksdk.channel.mobile.api.MobileConnectState;
import com.aliyun.alink.linksdk.tools.ALog;
import com.aliyun.alink.sdk.jsbridge.BonePluginRegistry;
import com.aliyun.iot.aep.demo.EnvConfigure;
import com.aliyun.iot.aep.sdk.connectchannel.BoneChannel;
import com.aliyun.iot.aep.sdk.framework.sdk.SDKConfigure;
import com.aliyun.iot.aep.sdk.framework.sdk.SimpleSDKDelegateImp;

import java.util.Map;

/**
 * Created by wuwang on 2017/10/30.
 */

public final class DownstreamConnectorSDKDelegate extends SimpleSDKDelegateImp {
    static final private String TAG = "DownstreamConnectorSDKDelegate";

    /* API: ISDKDelegate */

    @Override
    public int init(Application app, SDKConfigure configure, Map<String, String> args) {
        int ret = 0;
        //1.native sdk init
//        if (!"com.aliyun.iot.aep.demo".equals(ThreadTools.getProcessName(app, android.os.Process.myPid()))) {
//            return ret;
//        }
        ALog.setLevel(ALog.LEVEL_DEBUG);
        MobileConnectConfig config = new MobileConnectConfig();
        /* pre start */
        //三元组，指定apiclient host
        config.authServer = "api.link.aliyun.com";
        //长链接
        //config.channelHost = "ssl://100.67.80.75:80"; // 预发
        //config.isCheckChannelRootCrt = false;
        /*pre  end */

        config.appkey = args.get(EnvConfigure.KEY_APPKEY);
//        config.appkey = (String) EnvConfigure.getEnvArg(EnvConfigure.KEY_APPKEY);
        config.securityGuardAuthcode = "114d";
        MobileChannel.getInstance().startConnect(app, config, new IMobileConnectListener() {
            @Override
            public void onConnectStateChange(MobileConnectState state) {
                ALog.d(TAG,"onConnectStateChange(), state = "+state.toString());
                EnvConfigure.putEnvArg(EnvConfigure.KEY_TRACE_ID, MobileChannel.getInstance().getClientId());
            }
        });
        //2.register bonebriage
        BonePluginRegistry.register("BoneChannel", BoneChannel.class);

        ALog.d(TAG, "initialized");

        return ret;
    }

}
